﻿using Syncfusion.Data;
using Syncfusion.UI.Xaml.Grid;
using Syncfusion.UI.Xaml.Grid.Helpers;
using Syncfusion.UI.Xaml.TreeGrid;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Data;
using System.Drawing;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace SfDataGrid_MVVM
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.dataGrid.TableSummaryRows.Add(new GridTableSummaryRow()
            {
                ShowSummaryInRow = false,
                SummaryColumns = new ObservableCollection<ISummaryColumn>()
                {
                    new GridSummaryColumn()
                    {
                        Name = "PriceAmount",
                        MappingName="UnitPrice",
                        SummaryType= SummaryType.Int32Aggregate,  
                        Format="Total amount of unit price UnitPrice : {Sum:c}"
                    },
                }
            });
            this.dataGrid.QueryRowHeight += OnQueryRowHeight;
        }

        String displayText = "";
        private void OnQueryRowHeight(object sender, QueryRowHeightEventArgs e)
        {
            if (dataGrid.IsTableSummaryIndex(e.RowIndex))
            {
                var summary = this.dataGrid.View.Records.TableSummaries[0];
                if (summary.SummaryRow.ShowSummaryInRow)
                    displayText = SummaryCreator.GetSummaryDisplayTextForRow(summary, this.dataGrid.View);
                else
                    displayText = SummaryCreator.GetSummaryDisplayText(summary, "UnitPrice", this.dataGrid.View);
                var column = this.dataGrid.Columns["UnitPrice"];
                TextBlock textBlock = new TextBlock();
                var parentBorder = new Border { Child = textBlock };
                textBlock.Text = displayText;
                textBlock.TextWrapping = TextWrapping.Wrap;
                textBlock.MaxWidth = column.ActualWidth;
                textBlock.MaxHeight = double.PositiveInfinity;
                textBlock.Padding = new Thickness(10);
                parentBorder.Measure(new System.Windows.Size(textBlock.MaxWidth, textBlock.MaxHeight));
                e.Height = parentBorder.DesiredSize.Height; 
                e.Handled = true;
            }
        }
    }
}
